package it.unibo.ai.rec.ui;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.*;

import javax.imageio.ImageIO;
import javax.swing.JPanel;
import it.unibo.ai.rec.model.FluentsModel;
import it.unibo.ai.rec.model.RecTrace;

public abstract class FluentChartContainer extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -7594932032864047302L;
	protected FluentChartFactory factory;
	
	public FluentChartContainer(FluentChartFactory factory) {
		this.factory = factory;
	}
	
	public abstract JPanel getChartPanel();
	
	public abstract void update(RecTrace trace, FluentsModel model);
	
	public void toPNG(File file) throws IOException {
		JPanel chartPanel = getChartPanel();
		
		if(chartPanel == null)
			return;
		int w = chartPanel.getWidth();
	    int h = chartPanel.getHeight();
	    BufferedImage bi = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);
	    Graphics2D g = bi.createGraphics();
	    chartPanel.setOpaque(true);
	    chartPanel.setBackground(Color.white);
	    chartPanel.paint(g);
	    chartPanel.setOpaque(false);
	    ImageIO.write(bi, "png", file);
	}
}
